Type to search.

Create or update an ES|QL data source

  • PUT /_query/data_source/{name}
Auth The Elastic Stack includes Elastic's core products such as Elasticsearch, Kibana, Logstash, and Beats. Availability Experimental since 9.5 This functionality is experimental and is not ready for production usage. Experimental features may change or be removed at any time. Elastic will work to fix any issues, but experimental features are not subject to the support SLA of official GA features. Specific Support terms apply. Unless stated otherwise on the page, this functionality is available when your Elastic Stack is deployed on Elastic Cloud Hosted, Elastic Cloud Enterprise, Elastic Cloud on Kubernetes, and self-managed environments. This documentation corresponds to the latest patch available for each minor version. If you're not using the latest patch, check the release notes for changes.

Creates or replaces a named, type-specific data source configuration for ES|QL data federation. Datasets reference data source configurations to access external data. Names must be lowercase and follow index or alias naming rules.

ES|QL Data Federation

Required privileges

Cluster privileges manage

Path parameters

name string required

The data source name to create or update.

Query parameters

master_timeout union oneOf · default: 30s

Period to wait for a connection to the master node.

Values: -1 0
timeout union oneOf · default: 30s

The time to wait for the request to be completed.

Values: -1 0

Request body

type string required

The data source type. Currently, s3 is supported. The value must be lowercase and contain no whitespace.

description string

A free-text description of the data source.

settings map string to object

Type-specific connection and authentication settings. For s3, connection settings include region and endpoint. Authentication settings include auth and the credentials required by the selected authentication method.

Response

application/json
acknowledged boolean required

For a successful response, this value is always true. On failure, an exception is returned instead.